data {
    int N;		//	The number of trials
    array[N] int Res;	//	Responses:  1 denotes -, 2 denotes +
    array[N] real X;	//	Stimuli
    real min_sgm;	//	The lower boundary of sgm
    real max_sgm;	//	The upper boundary of sgm
    real p75;
}
parameters {
    real<lower = 0.0> v_sgm;
    real v_pse;
}
transformed parameters {
    real sgm;
    real pse;
    array[N] vector[2] p;		//	Probabilities for X[N]

    sgm = 0.0001 + v_sgm * (max_sgm - min_sgm) * 0.5;
    pse = (min_sgm + max_sgm) / 2.0 + v_pse * (max_sgm - min_sgm);
    for (i in 1:N){
        p[i][1] = 1 - Phi((X[i] - pse) / sgm);
        p[i][2] = Phi((X[i] - pse) / sgm);
    }
}
model {
    v_sgm ~ exponential(0.1); 
    v_pse ~ normal(0.0, 10.0);
    for (i in 1:N)
        Res[i] ~ categorical(p[i]);
}
generated quantities {
    real jnd;
    jnd = sgm * p75;
}
